//
//  BlackAndWhiteAppDelegate.m
//  Copyright 2009 David Phillip Oster
//
//    Licensed under the Apache License, Version 2.0 (the "License");
//    you may not use this file except in compliance with the License.
//    You may obtain a copy of the License at
//
//        http://www.apache.org/licenses/LICENSE-2.0
//
//    Unless required by applicable law or agreed to in writing, software
//    distributed under the License is distributed on an "AS IS" BASIS,
//    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//    See the License for the specific language governing permissions and
//    limitations under the License.
//

#import "BlackAndWhiteAppDelegate.h"
#import "ImageConverter.h"

@implementation BlackAndWhiteAppDelegate

@synthesize window = window_;


- (void)applicationDidFinishLaunching:(UIApplication *)application {    
  [window_ makeKeyAndVisible];
}

- (void)dealloc {
  [dest_ release];
  [src_ release];
  [window_ release];
  [super dealloc];
}

- (void)convertR:(float)r g:(float)g b:(float)b {
  ImageConverter *converter = [[[ImageConverter alloc] init] autorelease];
  UIImage *src = [UIImage imageNamed:@"sample.jpg"];
  UIImage *dest = [converter toBlackAndWhite:src red:r green:g blue:b];
  [dest_ setImage:dest];
  [dest_ setNeedsDisplay];
}


- (IBAction)choose:(id)sender {
  switch ([sender selectedSegmentIndex]) {
    case 0: [self convertR:1.0 g:0 b:0];  break;
    case 1: [self convertR:0 g:1.0 b:0];  break;
    case 2: [self convertR:0 g:0 b:1.0];  break;
    case 3: [self convertR:1./3. g:1./3. b:1./3.];  break;
    // Industry standard values.
    case 4: [self convertR:0.25 g:0.6 b:0.15];  break;
  }
}


@end
